#include "localization.h"
#include "preview.h"
#include "query.h"
#include "scope.h"

#include <iostream>
#include <sstream>
#include <fstream>

namespace sc = unity::scopes;
using namespace std;
using namespace scope;

class DummyActivation: public sc::ActivationQueryBase
{
    public:
        DummyActivation(sc::Result const& result, sc::ActionMetadata const& metadata, std::string const& widget_id, std::string const& action_id) :
            sc::ActivationQueryBase(result, metadata, widget_id, action_id)
        {
        }
        sc::ActivationResponse activate()
        {
            return sc::ActivationResponse(sc::ActivationResponse::ShowDash);
        }
};

void Scope::start(string const&) {
    setlocale(LC_ALL, "");
    string translation_directory = ScopeBase::scope_directory()
            + "/../share/locale/";
    bindtextdomain(GETTEXT_PACKAGE, translation_directory.c_str());
}

void Scope::stop() {
}

sc::SearchQueryBase::UPtr Scope::search(const sc::CannedQuery &query,
                                        const sc::SearchMetadata &metadata) {
    // Boilerplate construction of Query
    return sc::SearchQueryBase::UPtr(new Query(query, metadata, scope_directory()));
}

sc::PreviewQueryBase::UPtr Scope::preview(sc::Result const& result,
                                          sc::ActionMetadata const& metadata) {
    // Boilerplate construction of Preview
    return sc::PreviewQueryBase::UPtr(new Preview(result, metadata));
}

sc::ActivationQueryBase::UPtr Scope::perform_action(unity::scopes::Result const& result, unity::scopes::ActionMetadata const& metadata, std::string const& widget_id, std::string const& action_id)
{
    return sc::ActivationQueryBase::UPtr(new DummyActivation(result, metadata, widget_id, action_id));
}

#define EXPORT __attribute__ ((visibility ("default")))

// These functions define the entry points for the scope plugin
extern "C" {

EXPORT
unity::scopes::ScopeBase*
// cppcheck-suppress unusedFunction
UNITY_SCOPE_CREATE_FUNCTION() {
    return new Scope();
}

EXPORT
void
// cppcheck-suppress unusedFunction
UNITY_SCOPE_DESTROY_FUNCTION(unity::scopes::ScopeBase* scope_base) {
    delete scope_base;
}

}
